<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="分类名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入分类名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="分类编码" prop="code">
        <el-input v-model="queryParams.code" placeholder="请输入分类编码" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined,false)"
                   v-hasPermi="['conf:base-type-account:create']">新增
        </el-button>
      </el-col>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="list"
      :stripe="true"
      :show-overflow-tooltip="true"
      v-if="refreshTable"
      row-key="id"
      :default-expand-all="isExpandAll"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column width="200" label="分类名称" align="left" prop="name"/>
      <el-table-column width="200" label="分类编码" align="center" prop="code"/>
      <el-table-column width="100" label="排序" align="center" prop="sort"/>
      <el-table-column label="关联子公司"  align="left" prop="corpNames"/>
      <el-table-column width="240" label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button size="mini" type="text" icon="el-icon-plus" @click="openForm(scope.row.id,true)"
                     v-hasPermi="['conf:base-type-account:update']">新增
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id,false)"
                     v-hasPermi="['conf:base-type-account:update']">修改
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['conf:base-type-account:delete']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 对话框(添加 / 修改) -->
    <BaseTypeForm ref="formRef" @success="getList"/>
  </div>
</template>

<script>
import * as BaseTypeApi from '@/api/base/type';
import BaseTypeForm from '@/views/conf/baseType/BaseTypeForm.vue';

export default {
  name: "BaseTypeAccount",
  components: {
    BaseTypeForm,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 配置类型列表
      list: [],
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},
      // 查询参数
      queryParams: {
        parentId: null,
        name: null,
        type: '01',
        createTime: [],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true;
        const res = await BaseTypeApi.getBaseTypeList(this.queryParams);
        this.list = this.handleTree(res.data, "id", "parentId", "children", "0");
      } finally {
        this.loading = false;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 添加/修改操作 */
    openForm(id,addChild) {
      this.$refs["formRef"].open(id,this.queryParams.type,addChild);
    },

    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除名称为"' + row.name + '"的数据项?')
      try {
        await BaseTypeApi.deleteBaseType(id);
        await this.getList();
        this.$modal.msgSuccess("删除成功");
      } catch {
      }
    },

  }
};
</script>
